"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _opts = require("./opts");

var _babel = require("./babel");

var _default = options => {
  return async (next, ctx) => {
    ctx.console.log("Babel transform starting...");
    const opts = (0, _opts.getOpts)(options, ctx);

    if (ctx.emit) {
      ctx.emit("babel.opts", opts);
      await ctx.utils.sleep(100);
    }

    (0, _opts.validateOpts)(opts, ctx);
    const babelOpts = await (0, _babel.run)(opts, ctx);
    ctx.console.log("Babel transform finished.");
    await next({
      babelOpts
    });
  };
};

exports.default = _default;
module.exports = exports.default;