"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTransform = exports.getTSConfigCompilerOptions = exports.parseTSConfig = exports.getPkgFile = void 0;

var _path = require("path");

var _fs = require("fs");

var ts = _interopRequireWildcard(require("typescript"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const getPkgFile = ({
  cwd
}) => {
  let pkg = {};

  try {
    pkg = JSON.parse((0, _fs.readFileSync)((0, _path.join)(cwd, "package.json"), "utf-8"));
  } catch (e) {// do nothing
  }

  return pkg;
};

exports.getPkgFile = getPkgFile;

const parseTSConfig = path => {
  const result = ts.readConfigFile(path, file => (0, _fs.readFileSync)(file, "utf-8"));

  if (result.error) {
    return;
  }

  return result.config;
};

exports.parseTSConfig = parseTSConfig;

const getTSConfigCompilerOptions = path => {
  const config = parseTSConfig(path);
  return config ? config.compilerOptions : undefined;
};

exports.getTSConfigCompilerOptions = getTSConfigCompilerOptions;

const isTransform = (path, regexp) => {
  return regexp.test(path) && !path.endsWith(".d.ts");
};

exports.isTransform = isTransform;